	#include "loadlib.as"


	; ==============================================================================
	;
	; Track Bar
	;
	; ==============================================================================

#define trackbar_max		100
#define trackbar_min		0
#define tic_num			10
#define trackbar_step_page	10
#define	trackbar_width		300
#define	trackbar_height		50

	kernel32="kernel32.dll"
	user32="user32.dll"
;	comctl32="comctl32.dll"

	width 400,130
	button "I",*endp			:id+
	button "TrackBar",*trackbar_getpos	:id+

	gosub trackbar_create

	pos csrx,csry+trackbar_height
	;button "I",*endp	:id+
	last_y = csry

	trackbar_id = id	:id+
	act_id = 0
	max_id = id-1
*Lp
	getkey kSHIFT,16
	getkey kTAB,   9 : if kTAB = 1 : act_id += 1-(2*kSHIFT)
	if act_id > max_id : act_id = 0 : else if act_id < 0 : act_id = max_id
	if act_id = trackbar_id : gosub set_focus_trackbar : else : ginfo 1 : if prmx ! -1 : objsel act_id
	wait 10
	objsel -1 : if stat!-1 : act_id = stat
	goto *Lp

*trackbar_getpos
#define TBM_GETPOS	1024

	type="NNNN"
	hWnd=hTrackBarWnd
	uMsg=TBM_GETPOS
	wPrm=0
	lPrm=0
	gosub SendMessage
	dialog "TracBar:"+retSndMsg
	goto Lp


*endp
	ll_free
	end


*set_focus_trackbar
	hWnd=hTrackBarWnd : gosub SetFocus
	return


*trackbar_create
	gosub GetModuleHandle
	gosub GetActiveWindow
	hParentWnd=hActiveWnd

#define WS_CHILD	0x40000000
#define WS_VISIBLE	0x10000000

#define TBS_HORZ	0
#define TBS_VERT	2
#define TBS_AUTOTICKS	1
#define TBS_NOTICKS	16
#define TBS_TOP		4
#define TBS_BOTTOM	0
#define TBS_LEFT	4
#define TBS_RIGHT	0
#define TBS_BOTH	8
#define TBS_ENABLESELRANGE	32
#define TBS_FIXEDLENGTH	64
#define TBS_NOTHUMB	128
#define TBS_TOOLTIPS	256

	dwExStyle=0
	ClassName="msctls_trackbar32"
	WindowName=""
	trackbar_style = TBS_HORZ | TBS_RIGHT
	dwStyle= WS_CHILD | WS_VISIBLE | trackbar_style
	x=0
	y=csry
	w=trackbar_width
	h=trackbar_height
	gosub CreateWindowEx

	hTrackBarWnd=retCWE

	hWnd=hTrackBarWnd
	type="NNNN"
	gosub trackbar_set_range
	gosub trackbar_set_ticmark
	gosub trackbar_set_pagesize

	return


*trackbar_set_range
#define TBM_SETRANGE	1030

	uMsg=TBM_SETRANGE
	wPrm=1
	lPrm=trackbar_max<<16 | trackbar_min
	gosub SendMessage
	return

*trackbar_set_ticmark
#define TBM_SETTIC	1028

	uMsg=TBM_SETTIC
	wPrm=0

	tic = trackbar_max/tic_num
	i = tic_num - 1
	repeat i
	lPrm=tic
	gosub SendMessage
	tic += trackbar_max/tic_num
	loop

	return


*trackbar_set_pagesize
#define TBM_SETPAGESIZE	1045
;pageup,pagedownL[Ƃ̈ړ
	uMsg=TBM_SETPAGESIZE
	wPrm=0
	lPrm=trackbar_step_page
	gosub SendMessage
	return


*SetDLL
	ll_dll dll
	ll_func func
	ll_type type
	return

*Fcall
	ll_call
	error = stat
	if error = 1 : dialog "p[^̃^Cvsł(֐"+func+" : "+type+")"
	if error = 2 : dialog "LoadLibrarys܂("+dll+")"
	if error = 3 : dialog "GetProcAddresss܂(DLL "+dll+" : "+func+")"
	if error ! 0 : goto endp
	return

*GetActiveWindow
	dll=user32
	func="GetActiveWindow"
	type="V"
	gosub SetDLL
	gosub Fcall
	ll_ret hActiveWnd
	return

*GetModuleHandle
	dll  = kernel32
	func = "GetModuleHandleA"
	type = "N"
	gosub SetDLL
	ll_n 0
	gosub Fcall
	ll_ret hInst
	return

*CreateWindowEx
;	HWND CreateWindowEx(
;	  DWORD dwExStyle,	// extended window style
;	  LPCTSTR lpClassName,	// pointer to registered class name
;	  LPCTSTR lpWindowName,	// pointer to window name
;	  DWORD dwStyle,	// window style
;	  int x,	// horizontal position of window
;	  int y,	// vertical position of window
;	  int nWidth,	// window width
;	  int nHeight,	// window height
;	  HWND hWndParent,	// handle to parent or owner window
;	  HMENU hMenu,	// handle to menu, or child-window identifier
;	  HINSTANCE hInstance,	// handle to application instance
;	  LPVOID lpParam 	// pointer to window-creation data
;	);
	dll=user32
	func="CreateWindowExA"
	type="NSSNNNNNNNNN"
	gosub SetDLL
	ll_n dwExStyle
	ll_s ClassName
	ll_s WindowName
	ll_n dwStyle
	ll_n x
	ll_n y
	ll_n w
	ll_n h
	ll_n hParentWnd
	ll_n 0
	ll_n hInst
	ll_n 0
	gosub Fcall
	ll_ret retCWE
	return


*SendMessage
	dll  = user32
	func = "SendMessageA"
	gosub SetDLL
	ll_n hWnd
	ll_n uMsg
	peek wp_type,type,2 : if wp_type='P' : ll_p wPrm : else : ll_n wPrm
	peek lp_type,type,3 : if lp_type='P' : ll_p lPrm : else : ll_n lPrm
	gosub Fcall
	ll_ret retSndMsg
	return

*SetFocus
	dll = user32
	func="SetFocus"
	type="N"
	gosub SetDLL
	ll_n hWnd
	gosub Fcall
	return
