
;	hgimg.dll header
;	(for HSP2.68 or later)
;

#uselib "hgimg.dll"
#func _hgini hgini 2
#func hgsrc hgsrc 2
#func hgdst hgdst 2
#func hgdraw hgdraw 0
#func hgsync hgsync 2
#func hgbye hgbye $100
#func getsync getsync 1
#func sync sync 0
#func getdebug getdebug 1
#func hgsetreq hgsetreq 0
#func hggetreq hggetreq 1

#func setborder setborder 0
#func clscolor clscolor 0
#func clstex clstex 0
#func setfont setfont 0
#func fprt fprt 6

#func objset1 objset1 0
#func objadd1 objadd1 0
#func objmov1 objmov1 0
#func objsetf1 objsetf1 0
#func objaddf1 objaddf1 0
#func objmovf1 objmovf1 0
#func objcheck objcheck 1
#func objmovmode objmovmode 0
#func objmovopt objmovopt 0

#func objset2 objset2 0
#func objadd2 objadd2 0
#func objmov2 objmov2 0
#func objsetf2 objsetf2 0
#func objaddf2 objaddf2 0
#func objmovf2 objmovf2 0

#func objset3 objset3 0
#func objadd3 objadd3 0
#func objmov3 objmov3 0
#func objsetf3 objsetf3 0
#func objaddf3 objaddf3 0
#func objmovf3 objmovf3 0

#func selmoc selmoc 0
#func selpos selpos 0
#func selang selang 0
#func selscale selscale 0
#func seldir seldir 0

#func objgetfv objgetfv 1
#func objgetv objgetv 1
#func objsetfv objsetfv 1
#func objsetv objsetv 1
#func objaddfv objaddfv 1
#func objmovfv objmovfv 1
#func objgetstr objgetstr 1
#func objact objact 0

#func fvset fvset 1
#func fvseti fvseti 1
#func fvadd fvadd 1
#func fvsub fvsub 1
#func fvmul fvmul 1
#func fvdiv fvdiv 1
#func fvdir fvdir 1
#func fvget fvget 1
#func fvmin fvmin 1
#func fvmax fvmax 1
#func fvouter fvouter 1
#func fvinner fvinner 1
#func fvunit fvunit 1
#func fvface fvface 1
#func fv2str fv2str $11
#func f2str f2str $11
#func str2f str2f 5
#func str2fv str2fv 5
#func f2i f2i 1
#func fsin fsin 1
#func fcos fcos 1
#func fsqr fsqr 1
#func fadd fadd 1
#func fsub fsub 1
#func fmul fmul 1
#func fdiv fdiv 1
#func fcmp fcmp 1
#func froti froti 1

#func setuv setuv 0
#func setsizef setsizef 0
#func setbg setbg 0
#func getbg getbg $83
#func setmap setmap 0
#func addbox addbox 1
#func addplate addplate 1
#func addspr addspr 1
#func addbg addbg 1
#func regobj regobj 1
#func delobj delobj 0
#func setobjm setobjm 0
#func uvanim uvanim 0
#func setmode setmode 0
#func settimer settimer 0
#func setobjmode setobjmode 0
#func setcoli setcoli 0
#func getcoli getcoli 1
#func findobj findobj 0
#func nextobj nextobj 1

#func evmodel evmodel 0
#func setmtex setmtex 0
#func getmtex getmtex 1
#func getnode getnode $83

#func cammode cammode 0
#func selcam selcam 0
#func selcpos selcpos 0
#func selcang selcang 0
#func selcint selcint 0

#func copybuf copybuf 2

#func mxsend mxsend 1
#func mxconv mxconv 1
#func mxaconv mxaconv 1
#func mxgetpoly mxgetpoly 1
#func mxgetname mxgetname 1
#func settex settex 2
#func gettex gettex 1


#func addmesh addmesh 1


;
;	camera mode
;
#define CAM_MODE_NORMAL 0
#define CAM_MODE_LOOKAT 1

;
;	object mode
;
#define OBJ_HIDE 1
#define OBJ_TREE 2
#define OBJ_XFRONT 4
#define OBJ_UVANIM 8
#define OBJ_UVANIM_1SHOT 16
#define OBJ_MOVE 32
#define OBJ_FLIP 64
#define OBJ_BORDER 0x80
#define OBJ_2D 0x100
#define OBJ_TIMER 0x200
#define OBJ_WIPEBOM 0x400
#define OBJ_NOSORT 0x800
#define OBJ_GRAVITY 0x1000
#define OBJ_SKY 0x2000
#define OBJ_GROUND 0x4000

#define OBJMOV_STATIC 1
#define OBJMOV_LINEAR 2
#define OBJMOV_SPLINE 16

#define OBJMOV_OPT_AUTOKEY 0x400
#define OBJMOV_OPT_PARENT 0x2000
#define OBJMOV_OPT_REVERSE 0x4000
#define OBJMOV_OPT_ETERNAL 0x8000


;
;	node mode
;
#define NODE_ATTR_COLKEY 0x8000
#define NODE_ATTR_SPECULAR 0x4000
#define NODE_ATTR_ENVMAP 0x2000
#define NODE_ATTR_LIGHT 0x1000
#define NODE_ATTR_FOG 0x800
#define NODE_ATTR_EFX 0x400


;
;	system request
;
#define SYSREQ_NONE 0
#define SYSREQ_MAXMODEL 1
#define SYSREQ_MAXOBJ 2
#define SYSREQ_MAXTEX 3
#define SYSREQ_MAXMOC 4
#define SYSREQ_DXMODE 5
#define SYSREQ_DXHWND 6
#define SYSREQ_DXWIDTH 7
#define SYSREQ_DXHEIGHT 8
#define SYSREQ_COLORKEY 9



#module "HGIMG"

#deffunc hgini int,int

	;	initalize
	;
	mref p1,0
	mref p2,1
	mref bm,67
	hgmode = bm.3
	_hgini@ hgmode,p1,p2
	return


#deffunc texload str

	;	texture reg
	;
	mref fn,32
	buffer 3,100,100,hgmode
	picload fn
	settex@ winx,winy
	if stat : dialog "Texture Error("+stat+")" : return
	return


#deffunc texloadbg str

	;	texture reg
	;
	mref fn,32
	buffer 3,100,100,hgmode
	picload fn
	clstex@
	settex@ winx,winy,1
	if stat : dialog "Texture Error("+stat+")" : return
	return


#deffunc mxload str

	;	model load
	;
	mref fn,32
	mref _mdid,64
	fname = fn+".mx"
	exist fname
	if strsize<0 : dialog "file error ["+fname+"]" : end
	sdim buf,strsize
	s1=""
	bload fname,buf
	mxsend@ buf
	buffer 3,100,100,hgmode
	repeat
		mxgetname@ s1,cnt : if s1="" : break
		exist s1+".bmp"
		if strsize<0 : dialog "No file ["+s1+"]" : end
		texload s1+".bmp"
	loop
	mxconv@ mdid@		; Ro[gJn
	mxgetpoly@ polys@	; |S𓾂
	sdim buf,64
	_mdid = mdid@
	return



#global

